=== debian/changelog ===
qemu-kvm (1.2.0+noroms-0ubuntu2.12.10.7) quantal-security; urgency=medium

  * SECURITY UPDATE: arbitrary code execution via MAC address table update
    - debian/patches/CVE-2014-0150.patch: fix overflow in hw/virtio-net.c.
    - CVE-2014-0150
  * SECURITY UPDATE: denial of service and possible code execution via
    smart self test counter
    - debian/patches/CVE-2014-2894.patch: correct self-test count in
      hw/ide/core.c.
    - CVE-2014-2894
 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 25 Apr 2014 16:36:17 -0400

qemu-kvm (1.2.0+noroms-0ubuntu2.12.10.6) quantal-security; urgency=medium

  * SECURITY UPDATE: privilege escalation via REPORT LUNS
    - debian/patches/CVE-2013-4344.patch: support more than 256 LUNS in
      hw/scsi-bus.c, hw/scsi.h.
    - CVE-2013-4344
  * SECURITY UPDATE: denial of service in qdisk PV disk backend
    - debian/patches/CVE-2013-4375.patch: mark ioreq as mapped before
      unmapping in error case in hw/xen_disk.c.
    - CVE-2013-4375

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 28 Jan 2014 08:31:54 -0500

qemu-kvm (1.2.0+noroms-0ubuntu2.12.10.5) quantal-proposed; urgency=low

  * debian/control and qemu-kvm.postinst: remove any g:--- acl on /dev/kvm
    (left over from udev-acl).  (LP: #1057024)

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Wed, 17 Jul 2013 10:23:13 -0500

qemu-kvm (1.2.0+noroms-0ubuntu2.12.10.4) quantal-proposed; urgency=low

  * qemu-kvm.preinst: add kvm group if not present.  (LP: #1103022)

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Fri, 22 Mar 2013 10:14:18 -0500

qemu-kvm (1.2.0+noroms-0ubuntu2.12.10.3) quantal-proposed; urgency=low

  [ Nikolaus Rath ]
  * fix-usb-passthrough.patch: fix problems with accessing some host
    USB devices (Closes: 683983) (LP: #1033727)

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Tue, 29 Jan 2013 22:26:54 -0600

qemu-kvm (1.2.0+noroms-0ubuntu2.12.10.2) quantal-security; urgency=low

  * SECURITY UPDATE: guest denial of service and possible code execution
    via e1000 large packets
    - debian/patches/CVE-2012-6075.patch: properly discard oversize packets
      in hw/e1000.c.
    - CVE-2012-6075

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 15 Jan 2013 09:22:12 -0500

qemu-kvm (1.2.0+noroms-0ubuntu2.12.10.1) quantal-proposed; urgency=low

  [ Serge Hallyn ]
  * debian/qemu-kvm.postinst: use udevadm trigger to change /dev/kvm perms as
    recommended by Steve Langasek (LP: #1057024)
  * apply debian/patches/nbd-fixes-to-read-only-handling.patch from upstream to
    make read-write mount after read-only mount work.  (LP: #1077838)
  * make qemu-kvm depend on udev (LP: #1080912)

  [ Robert Collins ]
  * Fix upstart job to succeed if ksm settings can't be altered in the same way
    other settings are handled. (LP: #1078530)

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Mon, 19 Nov 2012 09:15:42 -0600

qemu-kvm (1.2.0+noroms-0ubuntu2) quantal-proposed; urgency=low

  * debian/rules: drop building of mpc8544ds from pc-bios (as it's no longer
    there) on powerpc to fix FTBFS.

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Mon, 24 Sep 2012 14:14:27 -0500

qemu-kvm (1.2.0+noroms-0ubuntu1) quantal; urgency=low

  * merge upstream v1.2.0  (LP: #1052932) (LP: #1040033)
    - debian/rules: remove --enable-kvm-device-assignment - configure switch
      no longer supported
    - remaining patches:
      . 02_use_usr_share_kvm_fixed.patch
      . 04_use_etc_kvm_kvm-ifup.patch
      . disable-hpet-for-tcg.patch
      . use-libexecdir.patch
      . ubuntu/larger_default_ram_size.patch
      . ubuntu/fallback-to-tcg.patch - ported to new code
      . ubuntu/dont-try-to-hotplug-cpu.patch
      . ubuntu/expose_vmx_qemu64cpu.patch
      . ubuntu/fix-vmware-vga-negative-vals
      . ubuntu/99-allow-loading-u-boot-initrd-images.patch

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Wed, 12 Sep 2012 10:46:28 -0500

qemu-kvm (1.1~rc+dfsg-1ubuntu11) quantal; urgency=low

  * Cherrypick three patches from upstream
    - kvm-i8254-fix-conversion-of-in-kernel-to-userspace-state
    - kvm-i8254-cache-kernel-clock-offset-in-KVMPITState
    - kvm-i8254-finish-time-conversion-fix
    to fix time passing too quickly in some guests.  (LP: #1046771)

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Thu, 06 Sep 2012 10:06:41 -0500

qemu-kvm (1.1~rc+dfsg-1ubuntu10) quantal; urgency=low

  * debian/qemu-kvm.modprobe: set nested=1 at module load.  (LP: #1040230)
  * remove patch ubuntu/define_AT_EMPTY_PATH, the real fix is now in eglibc.

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Thu, 23 Aug 2012 11:10:53 -0500

qemu-kvm (1.1~rc+dfsg-1ubuntu9) quantal; urgency=low

  [ Michael Tokarev ]
  * added two patches from upstream qemu-kvm/stable-1.1 branch:
    qemu-kvm-Add-missing-default-machine-options.patch
    qemu-kvm-virtio-Do-not-register-mask-notifiers-witho.patch
    (Closes: #679788) (LP: #1029201)

  [ Serge Hallyn ]
  * remove ubuntu/CVE-2011-2212-virtqueue-indirect-overflow.patch
    patch, which was actually fixed in qemu 0.15 by 
    "virtio: fix indirect descriptor buffer overflow"  (Thanks to
    Michael Tokarev for pointing that out)

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Thu, 26 Jul 2012 10:31:53 -0500

qemu-kvm (1.1~rc+dfsg-1ubuntu8) quantal; urgency=low

  * debian/qemu-kvm.upstart: don't fail if the kernel modules are not
    found.

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Wed, 11 Jul 2012 17:18:06 -0500

qemu-kvm (1.1~rc+dfsg-1ubuntu7) quantal; urgency=low

  * ubuntu/99-ppc-increase-usability-of-ppce500-pci.patch: Allows more than
    2 PCI devices on e500 type systems.
  * Enable ppc64-softmmu target on PowerPC as well

 -- Ben Collins <bcollins@ubuntu.com>  Thu, 28 Jun 2012 21:50:30 -0400

qemu-kvm (1.1~rc+dfsg-1ubuntu6) quantal; urgency=low

  * Add libfdt-dev [powerpc] to build-deps
  * Force --enable-fdt for powerpc builds
  * 99-allow-loading-u-boot-initrd-images.patch: Add capability to load
    initrd's in U-Image format.

